
/*
  Bondade da livraria       Jos M. C. Quintas "JoseQuintas.ch"
  Kindness of bookstore     Jos M. C. Quintas "JoseQuintas.ch"
  Amabilidad de la librera Jos M. C. Quintas "JoseQuintas.ch"

*/

// Harbour 3.2
#ifndef WIN_WS_EX_TRANSPARENT
   #define WIN_WS_EX_CLIENTEDGE   WS_EX_CLIENTEDGE
   #define WIN_WS_EX_TRANSPARENT  WS_EX_TRANSPARENT
   #define WIN_WM_GETFONT         WM_GETFONT
   #define WIN_WM_SETFONT         WM_SETFONT
   #define WIN_WM_SIZE            WM_SIZE
   #define WIN_WM_LBUTTONUP       WM_LBUTTONUP
   #define WIN_WM_SETTEXT         WM_SETTEXT
   #define EVENT_HANDLED          1
   #define EVENT_UNHANDLED        0
   #define PBS_MARQUEE            8
#endif

#include "hbclass.ch"
#include "inkey.ch"
#include "hbgtinfo.ch"

#include "hbgtwvg.ch"
#include "wvtwin.ch"
#include "wvgparts.ch"

CREATE CLASS TstAnimation INHERIT TstAny
   ENDCLASS

CREATE CLASS TstBitmap INHERIT TstAny
   VAR ClassName  INIT "STATIC"
   VAR ObjType    INIT objTypeStatic
   VAR Style      INIT WIN_WS_CHILD + WIN_WS_GROUP + SS_BITMAP + SS_CENTERIMAGE + BS_NOTIFY
   VAR nIconBimap INIT WIN_IMAGE_BITMAP
   ENDCLASS

/*

CREATE CLASS TstBitmap INHERIT TstAny
   VAR ClassName  INIT "STATIC"
   VAR ObjType    INIT objTypeStatic
   VAR Style      INIT WIN_WS_CHILD + WIN_WS_GROUP + SS_BITMAP + SS_CENTERIMAGE
   VAR nIconBimap INIT 2
   ENDCLASS
*/

CREATE CLASS TstButton INHERIT TstAny
   VAR className INIT "BUTTON"
   VAR objType   INIT objTypePushButton
   VAR style     INIT WIN_WS_CHILD + BS_PUSHBUTTON + BS_NOTIFY + BS_FLAT
   ENDCLASS

CREATE CLASS TstCheckBox INHERIT TstAny
   VAR ClassName INIT "BUTTON"
   VAR objType   INIT objTypeCheckBox
   VAR Style     INIT WIN_WS_CHILD + WIN_WS_TABSTOP + BS_AUTOCHECKBOX
   ENDCLASS

CREATE CLASS TstCombobox INHERIT TstAny
   VAR ClassName INIT "COMBOBOX"
   VAR ObjType   INIT objTypeComboBox
   VAR Style     INIT WIN_WS_CHILD + WIN_WS_BORDER+ WIN_WS_TABSTOP + WIN_WS_GROUP + CBS_DROPDOWNLIST
   ENDCLASS

CREATE CLASS TstDateTimePicker INHERIT TstAny
   ENDCLASS

CREATE CLASS TstEdit INHERIT TstAny
   VAR ClassName  INIT "EDIT"
   VAR objType    INIT objTypeSLE
   VAR Style      INIT WIN_WS_CHILD + WIN_WS_TABSTOP + WIN_WS_BORDER
   ENDCLASS

CREATE CLASS TstEditMultiline INHERIT TstAny
   VAR ClassName INIT "EDIT"
   VAR ObjType   INIT objTypeMLE
   VAR Style     INIT WIN_WS_CHILD + WIN_WS_TABSTOP + ES_AUTOVSCROLL + ES_MULTILINE + ;
      ES_WANTRETURN + WIN_WS_BORDER + WIN_WS_VSCROLL
   ENDCLASS

CREATE CLASS TstFlatScrollbar INHERIT TstAny
   ENDCLASS

CREATE CLASS TstFrame INHERIT TstAny
   VAR ClassName INIT "STATIC"
   VAR ObjType   INIT objTypeStatic
   VAR Style     INIT WIN_WS_CHILD + WIN_WS_GROUP + BS_GROUPBOX
   ENDCLASS

CREATE CLASS TstGroupbox INHERIT TstAny
   VAR className INIT "BUTTON"
   VAR objType   INIT objTypePushButton
   VAR style     INIT WIN_WS_CHILD + WIN_WS_VISIBLE + WIN_WS_TABSTOP + BS_GROUPBOX + WIN_WS_EX_TRANSPARENT
   ENDCLASS

CREATE CLASS TstHeader INHERIT TstAny
   VAR ClassName INIT "SysHeader32"
   VAR Style     INIT WS_CHILD + WS_BORDER + HDS_BUTTONS + HDS_HORZ
   ENDCLASS

CREATE CLASS TstHotkey INHERIT TstAny
   ENDCLASS

CREATE CLASS TstHyperlink INHERIT TstAny
   VAR ClassName  INIT "WC_LINK"
   VAR objType    INIT objTypePushButton 
   ENDCLASS

CREATE CLASS TstIcon INHERIT TstAny
   VAR ClassName   INIT "STATIC"
   VAR objType     INIT objTypeStatic
   VAR Style       INIT WIN_WS_CHILD + WIN_WS_GROUP + SS_ICON + SS_CENTERIMAGE
   VAR nIconBitmap INIT 1
   ENDCLASS

CREATE CLASS TstImage INHERIT TstAny
   VAR className INIT "STATIC"
   VAR objType   INIT objTypeStatic
   VAR style     INIT WIN_WS_CHILD
   ENDCLASS

CREATE CLASS TstImageList INHERIT TstAny
   ENDCLASS

CREATE CLASS TstIpAdress
   ENDCLASS

CREATE CLASS TstLineHorizontal INHERIT TstAny
   VAR ClassName  INIT "STATIC"
   VAR objType    INIT objTypeStatic
   VAR Style      INIT SS_ETCHEDHORZ + SS_SUNKEN
   ENDCLASS

CREATE CLASS TstLineVertical INHERIT TstAny
   VAR ClassName  INIT "STATIC"
   VAR objType    INIT objTypeStatic
   VAR Style      INIT SS_ETCHEDVERT + SS_SUNKEN
   ENDCLASS

CREATE CLASS TstListbox INHERIT TstAny
   VAR ClassName INIT "LISTBOX"
   VAR objType   INIT objTypeListBox
   VAR Style     INIT WIN_WS_CHILD + WIN_WS_VISIBLE + WIN_WS_TABSTOP + WIN_WS_BORDER + LBS_NOTIFY // + LBS_WANTKEYBOARDINPUT + WIN_WS_EX_CLIENTEDGE
   ENDCLASS

CREATE CLASS TstListView INHERIT TstAny
   ENDCLASS

CREATE CLASS TstMaskEdit INHERIT TstAny
   ENDCLASS

CREATE CLASS TstMonthCalendar INHERIT TstAny
   VAR ClassName INIT "SysMonthCal32"
   VAR objType   INIT objTypePushButton
   VAR Style     INIT WIN_WS_CHILD // + MCS_NOTODAY + MCS_NOTODAYCIRCLE + MCS_WEEKNUMBERS
   ENDCLASS

CREATE CLASS TstPager INHERIT TstAny
   ENDCLASS

CREATE CLASS TstPathEdit INHERIT TstAny
   ENDCLASS

CREATE CLASS TstProgressbar INHERIT TstAny
   VAR ClassName INIT "msctls_progress32"
   VAR ObjType   INIT objTypeStatic
   VAR Style     INIT WIN_WS_CHILD + WIN_WS_GROUP + PBS_MARQUEE + WIN_WS_EX_CLIENTEDGE
   ENDCLASS

CREATE CLASS TstRichEdit INHERIT TstAny
   ENDCLASS

CREATE CLASS TstRadioButton INHERIT TstAny
   VAR ClassName INIT "BUTTON"
   VAR ObjType   INIT objTypePushButton
   VAR Style     INIT WIN_WS_CHILD + WIN_WS_TABSTOP + BS_AUTORADIOBUTTON
   ENDCLASS

CREATE CLASS TstRebar INHERIT TstAny
   VAR ClassName INIT "reBarWindow32"
   END CLASS

CREATE CLASS TstScrollbar INHERIT TstAny
   ENDCLASS

CREATE CLASS TstscrollText INHERIT TstAny
   VAR ClassName INIT "RICHEDIT"
   VAR Style     INIT WIN_WS_CHILD + WIN_WS_TABSTOP + WIN_WS_VSCROLL + ES_AUTOVSCROLL + WIN_WS_GROUP + ES_READONLY
   ENDCLASS

CREATE CLASS TstStatusbar INHERIT TstAny
   VAR ClassName INIT "msctls_statusbar32"
   VAR Style  INIT WIN_WS_CHILD + WIN_WS_BORDER
   ENDCLASS

CREATE CLASS TstTab INHERIT TstAny
   ENDCLASS

CREATE CLASS TstTabCtl32 INHERIT TstAny
   VAR ClassName INIT "SysTabControl32"
   VAR Style     INIT WIN_WS_CHILD + TCS_FOCUSNEVER
   VAR objType   INIT objTypeTabPage
   ENDCLASS

CREATE CLASS TstTaskDialog INHERIT TstAny
   ENDCLASS

CREATE CLASS TstText INHERIT TstAny
   VAR ClassName INIT "STATIC"
   VAR objType   INIT objTypeStatic
   VAR Style     INIT WIN_WS_CHILD + WIN_WS_GROUP + SS_LEFT + WIN_WS_EX_TRANSPARENT + SS_SIMPLE // SS_LABEL
   ENDCLASS

CREATE CLASS TstToolbar INHERIT TstAny
   VAR ClassName INIT "ToolbarWindow32"
   ENDCLASS

CREATE CLASS TstTooltip INHERIT TstAny
   ENDCLASS

CREATE CLASS TstTrackbar INHERIT TstAny
   ENDCLASS

CREATE CLASS TstTreeview INHERIT TstAny
   ENDCLASS

CREATE CLASS TstUpDown INHERIT TstAny
   ENDCLASS


CREATE CLASS TstAny INHERIT WvgWindow

   VAR    autosize                              INIT .F.
   VAR    Border                                INIT .T.
   VAR    cancel                                INIT .F.
   VAR    cText
   VAR    default                               INIT .F.
   VAR    drawMode                              INIT WVG_DRAW_NORMAL
   VAR    preSelect                             INIT .F.
   VAR    pointerFocus                          INIT .F.
   VAR    Style                                 INIT 0
   VAR    cImage
   VAR    nIconBitmap                           INIT 0
   VAR    lSetCallback                          INIT .F.
   VAR    cFontName
   VAR    nFontSize

   METHOD new( oParent, oOwner, aPos, aSize, aPresParams, lVisible )
   METHOD create( oParent, oOwner, aPos, aSize, aPresParams, lVisible )
   METHOD configure( oParent, oOwner, aPos, aSize, aPresParams, lVisible )
   METHOD destroy()
   METHOD handleEvent( nMessage, aNM )

   METHOD activate( xParam )                    SETGET
   METHOD setText()
   METHOD SetImage()
   METHOD draw( xParam )                        SETGET

ENDCLASS


METHOD TstAny:new( oParent, oOwner, aPos, aSize, aPresParams, lVisible )

   ::wvgWindow:new( oParent, oOwner, aPos, aSize, aPresParams, lVisible )

   RETURN Self


METHOD TstAny:create( oParent, oOwner, aPos, aSize, aPresParams, lVisible )

   LOCAL hOldFont


   //DO CASE
   //CASE ::nIconBitmap == 1 ; ::style += BS_ICON
   //CASE ::nIconBitmap == 2 ; ::style += BS_BITMAP
   //ENDCASE

   ::wvgWindow:create( oParent, oOwner, aPos, aSize, aPresParams, lVisible )

   ::oParent:AddChild( Self )

   ::createControl()
   IF ::lSetCallback
      ::SetWindowProcCallback()  /* Let parent take control of it */
   ENDIF

   IF ::cFontName != NIL
      hOldFont := ::SendMessage( WIN_WM_GETFONT )
      ::SendMessage( WIN_WM_SETFONT, wvt_CreateFont( ::cFontName, ::nFontSize ), 0 )
      wvg_DeleteObject( hOldFont )
   ENDIF
   ::SetText()
   ::SetImage()
   IF ::visible
      ::show()
   ENDIF
   ::setPosAndSize()
   RETURN Self


METHOD TstAny:handleEvent( nMessage, aNM )

   DO CASE
   CASE nMessage == HB_GTE_RESIZED
      IF ::isParentCrt()
         ::rePosition()
      ENDIF
      ::sendMessage( WIN_WM_SIZE, 0, 0 )
      IF HB_ISEVALITEM( ::sl_resize )
         Eval( ::sl_resize, , , Self )
      ENDIF
      //IF ::WControlName $ "CMDBUTTON"
      //   ::Repaint()
      //ENDIF

   CASE nMessage == HB_GTE_COMMAND // .AND. ::WControlName $ "CMDBUTTON"
      IF aNM[ 1 ] == BN_CLICKED
         IF HB_ISEVALITEM( ::sl_lbClick )
            IF ::isParentCrt()
               ::oParent:setFocus()
            ENDIF
            Eval( ::sl_lbClick, , , Self )
            IF ::pointerFocus
               ::setFocus()
            ENDIF
         ENDIF
         RETURN EVENT_HANDLED
      ENDIF

   CASE nMessage == HB_GTE_NOTIFY

   CASE nMessage == HB_GTE_CTLCOLOR
      IF HB_ISNUMERIC( ::clr_FG )
         wapi_SetTextColor( aNM[ 1 ], ::clr_FG )
      ENDIF
      IF ! Empty( ::hBrushBG )
         wapi_SetBkMode( aNM[ 1 ], WIN_TRANSPARENT )
         RETURN ::hBrushBG
      ENDIF

   CASE ::lSetCallback .AND. nMessage == HB_GTE_ANY
      IF aNM[ 1 ] == WIN_WM_LBUTTONUP
         IF HB_ISEVALITEM( ::sl_lbClick )
            IF ::isParentCrt()
               ::oParent:setFocus()
            ENDIF
            Eval( ::sl_lbClick, , , Self )
         ENDIF
      ENDIF
   ENDCASE

   RETURN EVENT_UNHANDLED


METHOD PROCEDURE TstAny:destroy()

   LOCAL hOldFont

   IF ::cFontName != NIL
      hOldFont := ::SendMessage( WIN_WM_GETFONT )
      ::wvgWindow:destroy()
      wvg_DeleteObject( hOldFont )
   ENDIF

   RETURN


METHOD TstAny:configure( oParent, oOwner, aPos, aSize, aPresParams, lVisible )

   ::Initialize( oParent, oOwner, aPos, aSize, aPresParams, lVisible )

   RETURN Self


METHOD TstAny:SetText()
   IF HB_ISCHAR( ::cText )
      ::sendMessage( WIN_WM_SETTEXT, 0, ::cText )
   ENDIF
   RETURN NIL

METHOD TstAny:SetImage()
   DO CASE
   CASE ::cImage == NIL
   CASE ::nIconBitmap == 1 ; ::sendMessage( BM_SETIMAGE, WIN_IMAGE_ICON,   wvg_LoadImage( ::cImage, 1, WIN_IMAGE_ICON ) )
   CASE ::nIconBitmap == 2 ; ::sendMessage( BM_SETIMAGE, WIN_IMAGE_BITMAP, wvg_LoadImage( ::cImage, 1, WIN_IMAGE_BITMAP ) )
   ENDCASE
   RETURN NIL

METHOD TstAny:draw( xParam )

   IF HB_ISEVALITEM( xParam ) .OR. xParam == NIL
      ::sl_paint := xParam
   ENDIF

   RETURN Self


METHOD TstAny:activate( xParam )

   IF HB_ISEVALITEM( xParam ) .OR. xParam == NIL
      ::sl_lbClick := xParam
   ENDIF

   RETURN Self
