#require "gtwvg"
#require "hbtest"

#ifdef GTWVG
   #include "wvtwin.ch"
#endif

#include "inkey.ch"
#include "hbgtinfo.ch"
#include "JoseQuintas.ch"

#include "menu_01.prg"
#include "menu_02.prg"

#include "calendy.prg"
#include "calc.prg"

#include "radioButton.prg"
#include "print_txt.prg"
#include "print_pdf.prg"

#include "win_modal_00.prg"
#include "win_modal_01.prg"
#include "win_modal_02.prg"
#include "win_modal_03.prg"
#include "win_modal_04.prg"

#include "win_search_01.prg"
#include "win_search_02.prg"

*------------------------------------------------------------------------*
*------------------------------------------------------------------------*

  REQUEST DBFNTX  , DBFDBT

  REQUEST HB_Codepage_PTISO
* REQUEST HB_CODEPAGE_ESWIN

FUNCTION MAIN 

#if defined( __HBSCRIPT__HBSHELL ) .AND. defined( __PLATFORM__WINDOWS )
   hbshell_gtSelect( "GTWVG" )
#endif

*-------------------------------------------------*
  SET DATE FRENCH
  SET CENTURY ON
  SET DELETED ON
  SET ESCAPE ON
  SET DECIMALS TO 2
*-------------------------------------------------*
  Set( _SET_CODEPAGE, "PTISO" )   
  SET CURSOR OFF
  SET SCOREBOARD OFF
  Set( _SET_DATEFORMAT, "dd/mm/yyyy" )
  Set( _SET_EVENTMASK, hb_bitOr( INKEY_ALL, HB_INKEY_GTEVENT ) )
  SET SOFTSEEK ON
*-------------------------------------------------*
  IF FILE("xInfo.mem")  
     FileDelete("xInfo.mem")
  ENDIF
  IF FILE("Docu_TxT\"+".TXT")
     FileDelete("Docu_TxT\"+".TXT")
  ENDIF
*-------------------------------------------------*
*-------------------------------------------------*
   wvt_SetGUI( .T. )
   wvt_SetFont( "Courier New", 20, 0, 0 )    
   wvt_SetMouseMove( .T. )
   HB_GtInfo( HB_GTI_RESIZABLE, .F. )

   SetColor( "N/W" )
   CLS
   wvt_ShowWindow( SW_RESTORE )
   hb_gtInfo( HB_GTI_WINTITLE, "Harbour's and GTWvg Demo" )
   wvt_SetIcon( hb_DirBase() + "Resource\Careto.ico" )

   Wvt_DrawBoxRaised(3,3, MaxRow()-3, MaxCol()-3 )  

*  wvg_BoxRaised( 02,03,21,76, {-5,-5,5,5} )        //Optional 
*  wvg_BoxRecessed( 02,03,21,76 )                   //Optional 

   Myfunction()

   DO WHILE .T.
      IF Inkey(0.01) == K_ESC
         QUIT 
      ENDIF
    SetColor( "GR+/B" )  
    @ 23, 69 SAY Time()    //  <-  Relogio     Error Memory  SHOWTIME(23,69,.F.,"GR+/B",.F.,.F.)	    

   ENDDO

   RETURN NIL

*------------------------------------------------------------------*
*------------------------------------------------------------------*

*-----------------------------*
FUNCTION Myfunction()
*-----------------------------*

  Local SvE := SaveScreen (0 , 0, Maxrow(),MaxCol())
  Local wvtScr := Wvt_SaveScreen( 0, 0, MaxRow(), MaxCol() )

  CLS 
 
  TestMenubar()     // menu

  RestScreen ( 0 , 0, Maxrow(),MaxCol(), SvE)
  Wvt_RestScreen( 0, 0, MaxRow(), MaxCol(), wvtScr )

*--------------------------------------------- Box -----------------------------------------*
  Wvt_DrawBoxRaised(3,3, MaxRow()-3, MaxCol()-3 )  
  Wvt_DrawImage (04, 05 ,20, 74, "Resource\telafundo.jpg")
*-------------------------------------------------------------------------------------------*

  @ MaxRow() - 1 , 0 SAY PadC( "Navigate With Harbour's and GTWvg", maxcol()+ 1 ) COLOR "GR+/B"   
     
  SetColor( "GR+/B" )  
  @ 23,3 SAY DTOC(DATE())
* SHOWTIME(23,69,.F.,"GR+/B",.F.,.F.)	 //  <-------------  Error Memory CPU	         
 
  TestToolBar()   // menu

RETURN NIL

*-------------------------------------------------*
STATIC FUNCTION Exit_oSo() 
*-------------------------------------------------*
CLS
QUIT 

Return Nil
*--------------------------------------------------------------------*
*--------------------------------------------------------------------*

#if ! defined( __HBSCRIPT__HBSHELL )

PROCEDURE hb_GTSYS()  /* must be a public function */

   REQUEST HB_GT_WVG_DEFAULT
   REQUEST HB_GT_WVT
   REQUEST HB_GT_WGU
   RETURN

#endif


*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*
