*-------------------------------------*
STATIC FUNCTION TestMenubar()
*-------------------------------------*
   LOCAL oMenu 

   oMenu  := wvgSetAppWindow():MenuBar()
   ArrayToMenu( oMenu, MenuOptions1() )

   RETURN NIL
*-------------------------------------*
FUNCTION ArrayToMenu( oMenu, acMenu )
*-------------------------------------*
   LOCAL nCont, oSubMenu

   FOR nCont = 1 TO Len( acMenu )
      IF Len( acMenu[ nCont, 2 ] ) == 0
         oMenu:AddItem( acMenu[ nCont, 1 ], acMenu[ nCont, 3 ] )
      ELSE
         oSubMenu := WvgMenu():new( oMenu, , .T. ):Create()
         ArrayToMenu( oSubMenu, acMenu[ nCont, 2 ] )
         oMenu:AddItem( oSubMenu, acMenu[ nCont, 1 ] )
      ENDIF
   NEXT
   RETURN NIL
*-------------------------------------*
STATIC FUNCTION MenuOptions1()
*-------------------------------------*
                                 
   MEMVAR nMenuLevel, oMenuOptions
   PRIVATE nMenuLevel := 0, oMenuOptions := {}

    MenuOption( "First Menu" )
      MenuDrop()
      MenuOption( "First Group" )
         MenuDrop()
         MenuOption( "1 Browse"    , { || Win_Modal_011() , NIL } ) 
         MenuOption( "-")  
         MenuOption( "2 Memoedit"  , { || Win_Modal_044() , NIL } ) 
         MenuOption( "-")  
         MenuOption( "3 Search"    , { || Fi_Search_022() , NIL } )  
         MenuOption( "-")  
         MenuOption( "4 Dbedit"    , { || Win_Modal_033() , NIL } )              
         MenuUnDrop() 
      MenuOption( "Exit" )
         MenuDrop()
         MenuOption( "Exit", { || Exit_oSo() } )            //   MenuOption( "Exit", { || HB_KeyPut( K_ESC ) } )
         MenuUnDrop()
      MenuUnDrop()
      MenuOption( "Second Menu" )
      MenuDrop()
      MenuOption( "Second Group" )
         MenuDrop()
          MenuOption( "5 Photo"     , { || Win_Modal_022() , NIL } ) 
          MenuOption( "-")  
          MenuOption( "6 Calendary" , { || Calendary() , NIL } ) 
          MenuOption( "-")     
          MenuOption( "7 Calculator", { || Calcula()   , NIL } ) 
         MenuUnDrop()
      MenuUnDrop()
       MenuOption( "Third Menu" )
      MenuDrop()
      MenuOption( "Third Group" )
         MenuDrop()
          MenuOption( "8 Forms"    , { || RadioButto()  , NIL } )   
          MenuOption( "-")   
          MenuOption( "9 About"    , { || Mensa_About() , NIL } ) 
         MenuUnDrop()
      MenuUnDrop()
   MenuUnDrop()
   RETURN oMenuOptions

*-------------------------------------------------*
STATIC FUNCTION MenuOption( cCaption, bCode )
*-------------------------------------------------*
   LOCAL nCont, oLastMenu
   MEMVAR nMenuLevel, oMenuOptions

   oLastMenu := oMenuOptions
   FOR nCont = 1 to nMenuLevel
      oLastMenu := oLastMenu[ Len( oLastMenu ) ]
      IF ValType( oLastMenu[ 2 ] ) != "A"
         oLastMenu[ 2 ] := {}
      ENDIF
      oLastMenu := oLastMenu[ 2 ]
   NEXT
   Aadd( oLastMenu, { cCaption, {}, bCode } )
   RETURN NIL
*-------------------------------------------------*
STATIC FUNCTION MenuDrop()
*-------------------------------------------------*
   MEMVAR nMenuLevel
   nMenuLevel++
   RETURN NIL
*-------------------------------------------------*
STATIC FUNCTION MenuUnDrop()
*-------------------------------------------------*
   MEMVAR nMenuLevel
   nMenuLevel--
   RETURN NIL

*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*

