#include "hmg_hpdf.ch"
#include "inkey.ch"
#include "hbgtinfo.ch"

*----------------------------------------*
* (c) Mustafa Lpez  mustalopez@gmail.com
*----------------------------------------*

*---------------------------------------------------*
 FUNCTION pdf_create()
*---------------------------------------------------*
  LOCAL numero  , cNumero , cNombre 
  LOCAL horaS   , pext  
  LOCAL mVenta  , pVenta
  LOCAL Apext   , Bpext , Cpext , Dpext 
  LOCAL TOT   := 0.00           
  LOCAL F_Mus := 123         
  LOCAL pagina  , IVAX , TOTIS  
  LOCAL nValor  , ComasX  
  LOCAL AnValor , AComasX 
  LOCAL BnValor , BComasX  
  LOCAL CnValor , CComasX   
  LOCAL DnValor , DComasX   

*----------------------------------------------------------------------------*

  CLOSE DATABASES
  USE MESES
  SET CENTURY ON
  SET DATE FRENCH
  IF meses->ULTIMO_REC >= 99999
     REPLACE meses->ULTIMO_REC WITH 0
  ENDIF
  CLOSE DATABASES
  USE MESES
   SET CENTURY ON
   SET DATE FRENCH
    IF .NOT. meses->ULTIMO_REC = 1
       APPEND BLANK
       REPLACE meses->ULTIMO_REC WITH meses->ULTIMO_REC+0
       REPLACE meses->FECHA_FACT WITH DTOC(DATE())
       REPLACE meses->HORA WITH TIME() 
   ENDIF
  CLOSE DATABASES
  USE MESES
  REPLACE meses->ULTIMO_REC WITH meses->ULTIMO_REC+1
  DELETE FOR meses->ULTIMO_REC = 0
  PACK
  REPLACE meses->FECHA_FACT WITH DTOC(DATE())
  REPLACE meses->HORA WITH TIME() 

*------------------------------------------------------------------------------*
*  Respaldo de Seguridad ------------------------------------------------------*
*------------------------------------------------------------------------------*
  CLOSE DATABASES   
  USE MESES
  numero  :=ALLTRIM( STR(meses->ULTIMO_REC) ) 
  cNumero :=RTRIM(STRTRAN(numero,"/","_",1,len(numero)))
  cNombre:="Facturas_PdF\"+"Factura"+"_"+cNumero +".pdf"
  CLOSE DATABASES
*-------------------------------------------------------------------------------*
*---------------------------------------------------------------------------------------------*

*   SELECT HPDFDOC cNombre ORIENTATION HPDF_ORIENT_LANDSCAPE PAPERSIZE HPDF_PAPER_A4    // LANDSCAPE  Horizontal
    SELECT HPDFDOC cNombre ORIENTATION HPDF_ORIENT_PORTRAIT PAPERSIZE HPDF_PAPER_A4     // LANDSCAPE  Vertical

*-----------------------------  Cdigo Caracteres ANSI (Latinos) -----------------------------*
*------------------------------ Alternativo es lo Mismo --------------------------------------*

    SET HPDFDOC ENCODING TO "WinAnsiEncoding"
*   SET HPDFDOC ENCODING TO "CP1252"  

*-----------------------------------------------------------------------------------------------*

   START HPDFDOC
              
            START HPDFPAGE
		
            pagina:=1

*------------------------------------------------ Cuadro General ---------------------------------*

     @ 005,005  HPDFPRINT RECTANGLE TO 292, 206 PENWIDTH 1 ROUNDED CURVE 1  
     @ 007,007  HPDFPRINT RECTANGLE TO 290, 204            ROUNDED CURVE 1          

*-------------------------------------------------------------------------------------------------*
*------------------------------------------------ Recuadro Empresa -------------------------------*

     @ 018,018 HPDFPRINT RECTANGLE TO 056, 146 PENWIDTH 2 COLOR { 051, 051, 051 } FILLED ROUNDED CURVE 1   
     @ 016,016 HPDFPRINT RECTANGLE TO 054, 144 PENWIDTH 2 COLOR { 132, 193, 255 } FILLED ROUNDED CURVE 1  
*-------------------------------------------------------------------------------------------------*  
     @ 021,020 HPDFPRINT IMAGE "Resource\Logo.png" width 28 height 29  
*-------------------------------------------------------------------------------------------------*  
     SELECT 1
     USE VENTAS
    
     @ 026,055 HPDFPRINT ALLTRIM(VENTAS->NOMBR) + SPACE(1)+"S.L." FONT "Times-Roman" SIZE 12 ITALIC
     @ 030,055 HPDFPRINT VENTAS->DIRECCIO FONT "Times-Roman" SIZE 12 ITALIC
     @ 034,055 HPDFPRINT LTRIM(VENTAS->CODIG) + SPACE(1)+VENTAS->POBLACIO FONT "Times-Roman" SIZE 12 ITALIC
     @ 038,055 HPDFPRINT VENTAS->PROVI FONT "Times-Roman" SIZE 12 ITALIC
     @ 042,055 HPDFPRINT "Telf.:" + space(2) + LTRIM(VENTAS->TELEFON)+SPACE(6)+"Fax.:"+space(2)+LTRIM(VENTAS->FAXX) FONT "Times-Roman" SIZE 12 ITALIC
     @ 046,055 HPDFPRINT "NIF :"  + space(2) + LTRIM(VENTAS->NI) + space(2) + ALLTRIM(VENTAS->MAIL) FONT "Times-Roman" SIZE 12 ITALIC

*-------------------------------------------------------------------------------------------------*

     @ 062,015  HPDFPRINT RECTANGLE TO 72, 197  ROUNDED CURVE 1        
 
     SELECT 1
     USE VENTAS

     @ 066,020 HPDFPRINT "Cdigo Cliente:"+SPACE(13)+ ALLTRIM(STR(VENTAS->NUM_CLI)) FONT "Times-Roman" SIZE 12 ITALIC
     @ 070,020 HPDFPRINT "NIF: "+SPACE(4)+LTRIM(VENTAS->NIF)+SPACE(6)+"Telf.: "+SPACE(1)+LTRIM(VENTAS->TELEFONO)  FONT "Times-Roman" SIZE 12 ITALIC

     SELECT 2
     USE MESES

     @ 066,145 HPDFPRINT ALLTRIM( STR(MESES->ULTIMO_REC)) FONT "Times-Roman" SIZE 12 ITALIC
     @ 066,120 HPDFPRINT "Factura n.:" FONT "Times-Roman" SIZE 12 ITALIC

     horaS := LEFT(MESES->HORA, 5) 

     @ 070,145 HPDFPRINT ALLTRIM( MESES->FECHA_FACT) + SPACE(4) + ALLTRIM(horaS) FONT "Times-Roman" SIZE 12 ITALIC  
     @ 070,120 HPDFPRINT "Fecha Fact.:" FONT "Times-Roman" SIZE 12 ITALIC 
  
*-------------------------------------------------------------------------------------------------*

     @ 076,117 HPDFPRINT RECTANGLE TO 098, 197 PENWIDTH 0.1  ROUNDED CURVE 1       
*-------------------------------------------------------------------------------------------------*

     SELECT 1
     USE VENTAS
  
     @ 082,120 HPDFPRINT ALLTRIM(VENTAS->R_SOCIAL) FONT "Times-Roman" SIZE 12 ITALIC
     @ 086,120 HPDFPRINT "C/"+SPACE(1)+ALLTRIM(VENTAS->DIRECCION) FONT "Times-Roman" SIZE 12 ITALIC
     @ 090,120 HPDFPRINT LTRIM(VENTAS->CD_POSTAL)+SPACE(1)+ALLTRIM(VENTAS->POBLACION) FONT "Times-Roman" SIZE 12 ITALIC
     @ 094,120 HPDFPRINT ALLTRIM(VENTAS->PROVINCIA) FONT "Times-Roman" SIZE 12 ITALIC

*-------------------------------------------- Recuadro y Nombre de Productos ---------------------*

 
     @ 101,015 HPDFPRINT RECTANGLE TO 109, 197  ROUNDED CURVE 1       

     @ 106,020 HPDFPRINT  "Cdigo"+space(38)+"Nombre Artculo"+SPACE(31)+"Precio"+SPACE(10)+"Cantidad"+SPACE(12)+"Total" FONT "Times-Roman" SIZE 12 ITALIC  

 *-----------------------------------------  RECTANGLE Productos  ---------------------------------*


     @ 118,015 HPDFPRINT RECTANGLE TO 267, 197  ROUNDED CURVE 1       

     @ 118,032 HPDFPRINT LINE TO 267, 032 PENWIDTH 0.1 
     @ 118,128 HPDFPRINT LINE TO 267, 128 PENWIDTH 0.1 
     @ 118,153 HPDFPRINT LINE TO 267, 153 PENWIDTH 0.1 
     @ 118,174 HPDFPRINT LINE TO 267, 174 PENWIDTH 0.1 

*-------------------------------------------------------------------------------------------------*

    DO WHILE !ventas->(EOF())

*--------------------------------------------------------------------------------------------------*
*--------------------------------------- Facturacin Productos ------------------------------------*
*------------------------------------------------ REF ---------------------------------------------*

       @ F_Mus, 16 HPDFPRINT RTRIM( STR(ventas->REF) ) FONT "Times-Roman" SIZE 12 // ITALIC 

*--------------------------------------------- NOM_ART --------------------------------------------*

       @ F_Mus, 36 HPDFPRINT LTRIM( ventas->NOM_ART) FONT "Times-Roman" SIZE 12 ITALIC
          
*---------------------------------------------------------------------------------------------------*
 
       *---------------- Para ---->  PVENTA_E  ----------*  
       nValor   := ventas->PVENTA_E  
       ComasX   := TRANSFORM(nValor,"@E 9,999,999.99")   
       pext     := ALLTRIM(STR(nValor))

*--------------------------------------- Precio Artculo--------------------------------------------*

         IF LEN(pext) = 7 
            @ F_Mus,130 HPDFPRINT ComasX FONT "Times-Roman" SIZE 12 //ITALIC
         ENDIF   
         IF LEN(pext) = 6
            @ F_Mus,131 HPDFPRINT ComasX FONT "Times-Roman" SIZE 12 //ITALIC
         ENDIF   
         IF LEN(pext) = 5
            @ F_Mus,132 HPDFPRINT ComasX FONT "Times-Roman" SIZE 12 //ITALIC
         ENDIF   
         IF LEN(pext) = 4
            @ F_Mus,133 HPDFPRINT ComasX FONT "Times-Roman" SIZE 12 //ITALIC
         ENDIF   
         IF LEN(pext) = 3
            @ F_Mus,134 HPDFPRINT ComasX FONT "Times-Roman" SIZE 12 //ITALIC
         ENDIF   
*--------------------------------------------------------------------------------------------------*
           mVenta  := ventas->VENTA  
           pVenta  := ALLTRIM(STR(mVenta))  

*------------------------------------------- Cantidad Vendida --------------------------------------*

         IF LEN(pVenta) = 5 
            @ F_Mus,156 HPDFPRINT RTRIM(STR(ventas->VENTA)) FONT "Times-Roman" SIZE 12 // ITALIC
         ENDIF  
         IF LEN(pVenta) = 4 
            @ F_Mus,157 HPDFPRINT RTRIM(STR(ventas->VENTA)) FONT "Times-Roman" SIZE 12 //ITALIC
         ENDIF        
         IF LEN(pVenta) = 3
            @ F_Mus,158 HPDFPRINT RTRIM(STR(ventas->VENTA)) FONT "Times-Roman" SIZE 12 //ITALIC
         ENDIF        
          IF LEN(pVenta) = 2
            @ F_Mus,159 HPDFPRINT RTRIM(STR(ventas->VENTA)) FONT "Times-Roman" SIZE 12 //ITALIC
         ENDIF        
         IF LEN(pVenta) = 1
            @ F_Mus,160 HPDFPRINT RTRIM(STR(ventas->VENTA)) FONT "Times-Roman" SIZE 12 //ITALIC
         ENDIF        
*----------------------------------------------------------------------------------------------------*  
       *------------- Para -->  PVENTA_E*VENTA ----------*  
       AnValor   := (ventas->PVENTA_E)*(ventas->VENTA)
       AComasX   := TRANSFORM(AnValor,"@E 9,999,999.99")   
       Apext     := ALLTRIM(STR(AnValor))

*------------------------------------( Precio * Cantidad )= Total -----------------------------------*

         IF LEN(Apext) = 10
            @ F_Mus,169 HPDFPRINT  AComasX   FONT "Times-Roman" SIZE 12 // ITALIC
         ENDIF 
         IF LEN(Apext) = 9
            @ F_Mus,170 HPDFPRINT  AComasX   FONT "Times-Roman" SIZE 12 //ITALIC
         ENDIF 
         IF LEN(Apext) = 8           
            @ F_Mus,171 HPDFPRINT  AComasX  FONT "Times-Roman" SIZE 12 //ITALIC
         ENDIF
         IF LEN(Apext) = 7           
            @ F_Mus,172 HPDFPRINT  AComasX  FONT "Times-Roman" SIZE 12 //ITALIC
         ENDIF   
         IF LEN(Apext) = 6           
            @ F_Mus,174 HPDFPRINT  AComasX FONT "Times-Roman" SIZE 12 //ITALIC 
         ENDIF  
         IF LEN(Apext) = 5
            @ F_Mus,175 HPDFPRINT  AComasX  FONT "Times-Roman" SIZE 12 //ITALIC
         ENDIF  
         IF LEN(Apext) = 4           
            @ F_Mus,176 HPDFPRINT  AComasX  FONT "Times-Roman" SIZE 12 //ITALIC
         ENDIF 
          IF LEN(Apext) = 3
            @ F_Mus,177 HPDFPRINT  AComasX   FONT "Times-Roman" SIZE 12 //ITALIC
         ENDIF  

*------------------------------------------------------------------------------------------------------*
        
        TOT = TOT + AnValor        //(ventas->PVENTA_E)*(ventas->VENTA)       
  
*--------- TRANSFORM ---- Para -->  TOT----------*

         BnValor   := TOT
         BComasX   := TRANSFORM(BnValor,"@E 9,999,999.99")
         Bpext     := ALLTRIM(STR(BnValor))
*--------------------------------------------- n pagina  ------------------------------*

         @ 287, 098 HPDFPRINT "-"+SPACE(3)+ALLTRIM(STR(pagina))+SPACE(3)+"-" FONT "Times-Roman" SIZE 12 ITALIC

*---------------------------------------------------------------------------------------*

          F_Mus=F_Mus+4

        ventas->(dbskip())

          IF F_Mus > ( 123+140)   // <--------------- Salto de Pgina

             pagina:=pagina+1

*------------------------------------------ Total Suma y Sigue --------------------------*
         IF LEN(Bpext) = 9
               @ 277,170 HPDFPRINT BComasX  FONT "Times-Roman" SIZE 12 // ITALIC  
         ENDIF
         IF LEN(Bpext) = 8
               @ 277,171 HPDFPRINT BComasX FONT "Times-Roman" SIZE 12 // ITALIC
         ENDIF
         IF LEN(Bpext) = 7
               @ 277,173 HPDFPRINT BComasX  FONT "Times-Roman" SIZE 12 // ITALIC   ????? 172
         ENDIF
         IF LEN(Bpext) = 6
               @ 277,174 HPDFPRINT BComasX  FONT "Times-Roman" SIZE 12 // ITALIC
         ENDIF
         IF LEN(Bpext) = 5
               @ 277,176 HPDFPRINT BComasX  FONT "Times-Roman" SIZE 12 // ITALIC   
         ENDIF
         IF LEN(Bpext) = 4
               @ 277,176 HPDFPRINT BComasX  FONT "Times-Roman" SIZE 12 // ITALIC
         ENDIF
         IF LEN(Bpext) = 3
               @ 277,178 HPDFPRINT BComasX FONT "Times-Roman" SIZE 12 // ITALIC
         ENDIF

*----------------------------------------------------------------------------------------------*

         @ 277, 129 HPDFPRINT "Suma y Sigue    " FONT "Times-Roman" SIZE 12 ITALIC 


       END HPDFPAGE  
*-----------------------------------------------------------------*


      START HPDFPAGE
     
*--------------------------------------------------- Cuadro General ---------------------------------------------------*

     @ 005,005  HPDFPRINT RECTANGLE TO 292, 206 PENWIDTH 1  ROUNDED CURVE 1         
     @ 007,007  HPDFPRINT RECTANGLE TO 290, 204             ROUNDED CURVE 1       

*----------------------------------------------------------------------------------------------------------------------*
*----------------------------------------------------------------------------------------------------------------------*

*--------------------------------------------------- Recuadro Empresa -------------------------------------------------*

     @ 018,018 HPDFPRINT RECTANGLE TO 056, 146 PENWIDTH 2 COLOR { 051, 051, 051 } FILLED ROUNDED CURVE 1      
     @ 016,016 HPDFPRINT RECTANGLE TO 054, 144 PENWIDTH 2 COLOR { 132, 193, 255 } FILLED ROUNDED CURVE 1  

*-----------------------------------------------------------------------------------------------------------------------*  

     @ 021,020 HPDFPRINT IMAGE "Resource\Logo.png" width 28 height 29  

     @ 026,055 HPDFPRINT ALLTRIM(VENTAS->NOMBR) + SPACE(1)+"S.L." FONT "Times-Roman" SIZE 12 ITALIC
     @ 030,055 HPDFPRINT VENTAS->DIRECCIO FONT "Times-Roman" SIZE 12 ITALIC
     @ 034,055 HPDFPRINT LTRIM(VENTAS->CODIG) + SPACE(1)+VENTAS->POBLACIO FONT "Times-Roman" SIZE 12 ITALIC
     @ 038,055 HPDFPRINT VENTAS->PROVI FONT "Times-Roman" SIZE 12 ITALIC
     @ 042,055 HPDFPRINT "Telf.:" + space(2) + LTRIM( VENTAS->TELEFON)+SPACE(6)+"Fax.:"+space(2)+LTRIM(VENTAS->FAXX) FONT "Times-Roman" SIZE 12 ITALIC
     @ 046,055 HPDFPRINT "NIF :"  + space(2) + LTRIM( VENTAS->NI) + space(2) +  ALLTRIM(VENTAS->MAIL) FONT "Times-Roman" SIZE 12 ITALIC

*-------------------------------------------------------------------------------------------------------------------------*

     @ 062,015 HPDFPRINT RECTANGLE TO 72, 197 ROUNDED CURVE 1       

     @ 066,020 HPDFPRINT "Cdigo Cliente:"+SPACE(13)+ ALLTRIM(STR(VENTAS->NUM_CLI)) FONT "Times-Roman" SIZE 12 ITALIC
     @ 070,020 HPDFPRINT "NIF: "+SPACE(4)+LTRIM(VENTAS->NIF)+SPACE(6)+"Telf.: "+SPACE(1)+LTRIM(VENTAS->TELEFONO)  FONT "Times-Roman" SIZE 12 ITALIC
     @ 066,145 HPDFPRINT  ALLTRIM( STR(MESES->ULTIMO_REC)) FONT "Times-Roman" SIZE 12 ITALIC
     @ 066,120 HPDFPRINT "Factura n.:" FONT "Times-Roman" SIZE 12 ITALIC

     horaS := LEFT(MESES->HORA, 5)      //   <- solo Hora y Minutos ALLTRIM(HORA) <-- Hora Completa    

     @ 070,145 HPDFPRINT ALLTRIM( MESES->FECHA_FACT) + SPACE(4) + ALLTRIM(horaS) FONT "Times-Roman" SIZE 12 ITALIC   
     @ 070,120 HPDFPRINT "Fecha Fact.:" FONT "Times-Roman" SIZE 12 ITALIC 
  
*-------------------------------------------------------------------------------------------------------------------------*

     @ 076,117 HPDFPRINT RECTANGLE TO 098, 197 PENWIDTH 0.1 ROUNDED CURVE 1       

     @ 082,120 HPDFPRINT ALLTRIM(VENTAS->R_SOCIAL) FONT "Times-Roman" SIZE 12 ITALIC
     @ 086,120 HPDFPRINT "C/"+SPACE(1)+ALLTRIM(VENTAS->DIRECCION) FONT "Times-Roman" SIZE 12 ITALIC
     @ 090,120 HPDFPRINT LTRIM(VENTAS->CD_POSTAL)+SPACE(1)+ALLTRIM(VENTAS->POBLACION) FONT "Times-Roman" SIZE 12 ITALIC
     @ 094,120 HPDFPRINT ALLTRIM(VENTAS->PROVINCIA) FONT "Times-Roman" SIZE 12 ITALIC

*-------------------------------------------------- Recuadro y Nombre de Productos ---------------------------------------*

     @ 101,015 HPDFPRINT RECTANGLE TO 109, 197  ROUNDED CURVE 1       

     @ 106,020 HPDFPRINT "Cdigo"+space(38)+"Nombre Artculo"+SPACE(31)+"Precio"+SPACE(10)+"Cantidad"+SPACE(12)+"Total" FONT "Times-Roman" SIZE 12 ITALIC  
   
*-------------------------------------------------------- Total ----------------------------------------------------------*
        
         IF LEN(Bpext) = 9
               @ 115,170 HPDFPRINT BComasX  FONT "Times-Roman" SIZE 12 // ITALIC  
         ENDIF
         IF LEN(Bpext) = 8
               @ 115,171 HPDFPRINT BComasX  FONT "Times-Roman" SIZE 12 //ITALIC  
         ENDIF
         IF LEN(Bpext) = 7
               @ 115,173 HPDFPRINT BComasX  FONT "Times-Roman" SIZE 12 //ITALIC  ????  172 
         ENDIF
         IF LEN(Bpext) = 6
               @ 115,174 HPDFPRINT BComasX FONT "Times-Roman" SIZE 12 //ITALIC  
         ENDIF
         IF LEN(Bpext) = 5
               @ 115,176 HPDFPRINT BComasX  FONT "Times-Roman" SIZE 12 //ITALIC   
         ENDIF
         IF LEN(Bpext) = 4
               @ 115,176 HPDFPRINT BComasX FONT "Times-Roman" SIZE 12 //ITALIC  
          ENDIF
         IF LEN(Bpext) = 3
               @ 115,178 HPDFPRINT BComasX FONT "Times-Roman" SIZE 12 //ITALIC  
         ENDIF
*---------------------------------------------------------------------------------------------------------------------------*

        @ 115,129 HPDFPRINT  "Suma Anterior   " FONT "Times-Roman" SIZE 12 ITALIC  

*-----------------------------------------  RECTANGLE Productos  -----------------------------------------------------------*

        @ 118,015 HPDFPRINT RECTANGLE TO 267, 197  ROUNDED CURVE 1       

        @ 118,032 HPDFPRINT LINE TO 267, 032 PENWIDTH 0.1 
        @ 118,128 HPDFPRINT LINE TO 267, 128 PENWIDTH 0.1 
        @ 118,153 HPDFPRINT LINE TO 267, 153 PENWIDTH 0.1 
        @ 118,174 HPDFPRINT LINE TO 267, 174 PENWIDTH 0.1 

*---------------------------------------------------------------------------------------------------------------------------*
   
        F_Mus = 123

        endif
   ENDDO
   

   Ivax  := TOT * 21/100
   Totis := TOT + Ivax

 *-----------------------------------------------------------------*
 *--------------------------- Para -->   Ivax ---------------------*
 *-----------------------------------------------------------------*

         CnValor   :=  Ivax
         CComasX   := TRANSFORM(CnValor,"@E 9,999,999.99")
         Cpext     := ALLTRIM(STR(CnValor))

 *-----------------------------------------------------------------*
 *---------------------------- Para -->    Totis ------------------*
 *-----------------------------------------------------------------*

         DnValor   := Totis
         DComasX   := TRANSFORM(DnValor,"@E 9,999,999.99")
         Dpext     := ALLTRIM(STR(DnValor))

*-------------------------------------------------------------------------------------------------------------------------*

        @ 269,122 HPDFPRINT RECTANGLE TO 283, 197 PENWIDTH 0.1  ROUNDED CURVE 1         

        @ 273,125 HPDFPRINT  "Base Imponible"+SPACE(2)+"" FONT "Times-Roman" SIZE 12 ITALIC  
        @ 277,125 HPDFPRINT  "I.V.A. 21 %" FONT "Times-Roman" SIZE 12 ITALIC  
        @ 281,125 HPDFPRINT  "Total Factura"+SPACE(6)+""  FONT "Times-Roman" SIZE 12 ITALIC  

 *------------------------------------------------------------------*
 *--------------------------- Total = Suma -------------------------*
 *------------------------------------------------------------------*

         IF LEN(Bpext) = 16
               @ 273,163 HPDFPRINT BComasX FONT "Times-Roman" SIZE 12  // ITALIC  
         ENDIF
         IF LEN(Bpext) = 15
               @ 273,164 HPDFPRINT BComasX FONT "Times-Roman" SIZE 12 // ITALIC  
         ENDIF
         IF LEN(Bpext) = 14
               @ 273,165 HPDFPRINT BComasX FONT "Times-Roman" SIZE 12 // ITALIC  
         ENDIF
         IF LEN(Bpext) = 13
               @ 273,166 HPDFPRINT BComasX FONT "Times-Roman" SIZE 12 // ITALIC    
         ENDIF
         IF LEN(Bpext) = 12
               @ 273,167 HPDFPRINT BComasX FONT "Times-Roman" SIZE 12 // ITALIC  
         ENDIF
         IF LEN(Bpext) = 11
               @ 273,168 HPDFPRINT BComasX FONT "Times-Roman" SIZE 12 // ITALIC         
         ENDIF
         IF LEN(Bpext) = 10
               @ 273,169 HPDFPRINT BComasX FONT "Times-Roman" SIZE 12 // ITALIC  
         ENDIF
         IF LEN(Bpext) = 9
               @ 273,170 HPDFPRINT BComasX FONT "Times-Roman" SIZE 12 // ITALIC  
         ENDIF
         IF LEN(Bpext) = 8
               @ 273,171 HPDFPRINT BComasX FONT "Times-Roman" SIZE 12 // ITALIC  
         ENDIF
         IF LEN(Bpext) = 7
               @ 273,175 HPDFPRINT BComasX FONT "Times-Roman" SIZE 12 // ITALIC  
         ENDIF
         IF LEN(Bpext) = 6
               @ 273,174 HPDFPRINT BComasX FONT "Times-Roman" SIZE 12 // ITALIC  
         ENDIF
         IF LEN(Bpext) = 5
               @ 273,175 HPDFPRINT BComasX FONT "Times-Roman" SIZE 12 // ITALIC  
         ENDIF
         IF LEN(Bpext) = 4
               @ 273,176 HPDFPRINT BComasX FONT "Times-Roman" SIZE 12 // ITALIC  
         ENDIF
         
*---------------------------------------- Iva ---------------------------------------*
    
         IF LEN(Cpext) = 10       
               @ 277,169 HPDFPRINT   CComasX  FONT "Times-Roman" SIZE 12 // ITALIC  
         ENDIF 
         IF LEN(Cpext) = 9      
               @ 277,170 HPDFPRINT  CComasX FONT "Times-Roman" SIZE 12 // ITALIC  
         ENDIF 
         IF LEN(Cpext) = 8       
               @ 277,171 HPDFPRINT   CComasX  FONT "Times-Roman" SIZE 12 // ITALIC  
         ENDIF
         IF LEN(Cpext) = 7       
               @ 277,172 HPDFPRINT   CComasX  FONT "Times-Roman" SIZE 12 // ITALIC   
         ENDIF 
         IF LEN(Cpext) = 6       
               @ 277,176 HPDFPRINT   CComasX FONT "Times-Roman" SIZE 12 // ITALIC  
         ENDIF 
         IF LEN(Cpext) = 5       
               @ 277,175 HPDFPRINT  CComasX  FONT "Times-Roman" SIZE 12 // ITALIC  
         ENDIF 
         IF LEN(Cpext) = 4       
               @ 277,176 HPDFPRINT   CComasX  FONT "Times-Roman" SIZE 12 // ITALIC  
         ENDIF 
         
 *------------------------------------------  Totis ---------------------------------*
 
         IF LEN(Dpext) = 16
               @ 281,163 HPDFPRINT DComasX FONT "Times-Roman" SIZE 12 // ITALIC  
         ENDIF
         IF LEN(Dpext) = 15
               @ 281,164 HPDFPRINT DComasX FONT "Times-Roman" SIZE 12 // ITALIC  
         ENDIF
          IF LEN(Dpext) = 14
               @ 281,165 HPDFPRINT DComasX FONT "Times-Roman" SIZE 12 // ITALIC  
         ENDIF
         IF LEN(Dpext) = 13
               @ 280,166 HPDFPRINT DComasX FONT "Times-Roman" SIZE 12 // ITALIC  
         ENDIF
         IF LEN(Dpext) = 12
               @ 281,167 HPDFPRINT DComasX FONT "Times-Roman" SIZE 12 // ITALIC  
         ENDIF
         IF LEN(Dpext) = 11
               @ 281,168 HPDFPRINT DComasX  FONT "Times-Roman" SIZE 12 //  ITALIC  
         ENDIF
         IF LEN(Dpext) = 10
               @ 281,169 HPDFPRINT DComasX FONT "Times-Roman" SIZE 12 // ITALIC  
         ENDIF
         IF LEN(Dpext) =  9
               @ 281,170 HPDFPRINT DComasX  FONT "Times-Roman" SIZE 12 // ITALIC  
         ENDIF
         IF LEN(Dpext) =  8   
               @ 281,171 HPDFPRINT DComasX  FONT "Times-Roman" SIZE 12 // ITALIC  
         ENDIF
         IF LEN(Dpext) =  7
               @ 281,175 HPDFPRINT DComasX  FONT "Times-Roman" SIZE 12 // ITALIC  
         ENDIF
         IF LEN(Dpext) =  6
               @ 281,174 HPDFPRINT DComasX  FONT "Times-Roman" SIZE 12 // ITALIC  
         ENDIF
         IF LEN(Dpext) =  5
               @ 281,174 HPDFPRINT DComasX  FONT "Times-Roman" SIZE 12 // ITALIC  
         ENDIF
         IF LEN(Dpext) =  4
               @ 281,176 HPDFPRINT DComasX  FONT "Times-Roman" SIZE 12 // ITALIC  
         ENDIF
       
*------------------------------------------------------------------------------------*

        END HPDFPAGE  
                
    END HPDFDOC   

*------------------------------------------------------------------------------------*
 
  End_PrintQ()       // <-------------- MessageBox

*------------------------------------- View File PDF --------------------------------*
 IF FILE("xInfo.mem")
    Wapi_ShellExecute( NIL, "open", cNombre )               
    FileDelete("xInfo.mem")
 ENDIF
*------------------------------------------------------------------------------------*

RETURN NIL

*----------------------------------*
FUNCTION  End_PrintQ()
*----------------------------------*

LOCAL numeropQ := ALLTRIM( STR(meses->ULTIMO_REC) ) 
LOCAL CRLFpQ   := ( CHR(10) + CHR(13) )
LOCAL cTextpQ  := CRLFpQ + SPACE(3) + "Factura N "+ numeropQ + CRLFpQ + CRLFpQ ;
                        + SPACE(3) + "Factura_"+ ALLTRIM( numeropQ )+".pdf" , ;
                          cTitlepQ := "End Print"          
 wapi_MessageBox( wapi_GetActiveWindow(), cTextpQ, cTitlepQ, MB_ICONASTERISK )  

CLOSE DATABASES   

RETURN NIL


*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*
















   
